<?php declare(strict_types=1);

namespace Infomaker\ProjectPlugin\Admin;

use Infomaker\Everyware\Support\Collection;

class MessageBag
{
    private static $instance;

    private $messages;

    private function __construct()
    {
        $this->messages = new Collection();
    }

    public static function add(Message $message): void
    {
        static::getInstance()->addMessage($message);
    }

    private function addMessage(Message $message): void
    {
        $this->messages->push($message);
    }

    private static function getInstance(): MessageBag
    {
        if(static::$instance === null) {
            static::$instance = new static();
        }

        return static::$instance;
    }

    public static function renderMessages(): void
    {
        echo static::messagesToHtml();
    }

    public static function messagesToHtml(): string
    {
        return implode('', static::getInstance()->getMessages()->map(function(Message $message) {
            return $message->toHtml();
        })->toArray());
    }

    public function getMessages(): Collection
    {
        return $this->messages;
    }
}
